% function [SLeftDiffVec, SRightDiffVec]  = DiffVector(G)
% Input: G - two-rows matrix (the third dim can be > 1)
% output: SLeftDiffVec- differnces between the first row left by 1
% to the second row. SRightDiffVec - second row left by 1

function [SLeftDiffVec, SRightDiffVec]  = DiffVector(G)

[m,n,c] = size(G);

if(m~=2)
    disp('Error: should be 2 lines!');
    return;
end

SLeftDiffVec = zeros(1,n,c);
SRightDiffVec = zeros(1,n,c);

for i=1:c
    % shifts the first row left by 1 (the source is to the left side of (i,j)
    SLeftDiffVec(1,:,c) = abs([G(1,2:n,c) 0] - G(2, 1:n,c));
    SLeftDiffVec(1,end,c)=  0;
    % shifts the second row left by 1 (the source is to the right side of (i,j)
    SRightDiffVec(1,:,c) = abs([0 G(1,1:n-1,c)] - G(2, 1:n,c));
    SRightDiffVec(1,1,c)=  0;
end

