function [ VerticE, HoriznE] = MVEnergyUnreach(Disp_2Lines, I_2Lines, j_unreach,NM_map)
% the number of unreachable indices
K = length(j_unreach);
[m,n,view_num] = size(Disp_2Lines);
x = meshgrid(1:n,1:2);
X = MapDisp(round(Disp_2Lines));
X_source  = repmat(X(1,:),[K 1]);
X_unreach = repmat(X(2, j_unreach)',[1 n]); 
% the energy that correspond to each of the cases (terms 1-3)
VerticE = Inf(K,n);
CurrI = I_2Lines(2,:);

[SLeftDiffVec, SRightDiffVec]  = DiffVector(I_2Lines);
LeftCumSum = cumsum(SLeftDiffVec);
RightCumSum = cumsum(SRightDiffVec);

Leftidx = X_source < X_unreach & X_unreach < n+1 & X_source > 0; % the source is on the left of the current pixel
Rightidx = (X_source > X_unreach & X_source <n+1 & X_unreach > 0); % the source is on the right of the current pixel

for k=1:K
      
    if(X_unreach(k,1)-1<=0)
        continue;
    end
    ind_l =find(Leftidx(k,:)==1);
    ind_l = ind_l(X_source(k,ind_l)'-1> 0);
    ind_r = find(Rightidx(k,:)==1);
    ind_r   = ind_r(X_source(k,ind_r'-1)-1 >0);
    if(~isempty(ind_l))
        VerticE(k,ind_l)  = LeftCumSum(X_unreach(k,1)-1) - LeftCumSum(X_source(k,ind_l)'-1)';
    end
    if(~isempty(ind_r))
        VerticE(k,ind_r) =  RightCumSum(X_source(k,ind_r)')' - RightCumSum(X_unreach(k,1));
    end
end
VerticE(:,NM_map~=0) = Inf;
 ind  = find(X_unreach(:,1)>1 & X_unreach(:,1)<n);
 HoriznE = Inf(K,1);
 if(~isempty(ind))
    HoriznE(ind,:) = abs(I_2Lines(2,(X_unreach(ind,1)-1)) - I_2Lines(2,X_unreach(ind,1)+1))';
 end
 HoriznE = repmat(HoriznE, [1 n]); 
end