function [E1,E2,E3] = MVEnergy(Disp_2Lines, I_2Lines)

[m,n,view_num] = size(Disp_2Lines);
j = zeros(1,n-2);
j = 2:n-1 ;
x = meshgrid(1:n,1:2);
X = MapDisp(Disp_2Lines);
% the energy that correspond to each of the cases (terms 1-3)
E1 = zeros(1,n-2);
E2 = zeros(1,n-2);
E3 = zeros(1,n-2);
% The coordinates in the second image that corresponds to 2:n-1 in the ref
X0 = X(2,j);
% The coordinates in the second image that corresponds to 1:n-2 in the ref
X1 = X(1,j-1);
% The coordinates in the second image that corresponds to 1:n-2 in the ref
X2 = X(1,j);
% The coordinates in the second image that corresponds to 3:n in the ref
X3 = X(1,j+1);

CurrI = I_2Lines(:,2);

[SLeftDiffVec, SRightDiffVec]  = DiffVector(I_2Lines);
LeftCumSum = cumsum(SLeftDiffVec);
RightCumSum = cumsum(SRightDiffVec);

Leftidx1 = find(X1 < X0 ); % the source is on the left of the current pixel
Rightidx1 = find(X1 > X0); % the source is on the right of the current pixel

Leftidx2 = find(X2 < X0);
Rightidx2 = find(X2 > X0);

Leftidx3 = find(X3 < X0);
Rightidx3 = find(X3 > X0);

ind = [1:n-1]';
E1(Leftidx1)  = interp1q(ind,LeftCumSum',X0(Leftidx1)'-1) - interp1q(ind,LeftCumSum',X1(Leftidx1)'-1);
E1(Rightidx1) = interp1q(ind,RightCumSum',X1(Rightidx1)'-1) - interp1q(ind,RightCumSum',X0(Rightidx1)'-1);

E2(Leftidx2) = interp1(ind,LeftCumSum',X0(Leftidx2)'-1) - interp1(ind,LeftCumSum',X2(Leftidx2)'-1);
E2(Rightidx2) = interp1(ind,RightCumSum',X2(Rightidx2)'-1) - interp1(ind,RightCumSum',X0(Rightidx2)'-1);

E3(Leftidx3) = interp1(ind,LeftCumSum',X0(Leftidx3)'-1) - interp1(ind,LeftCumSum',X3(Leftidx3)'-1);
E3(Rightidx3) = interp1(ind,RightCumSum',X3(Rightidx3)'-1) - interp1(ind,RightCumSum',X0(Rightidx3)'-1);

E1 = E1+ abs(interp1q(ind,I_2Lines(:,2),X0-1) - interp1q(ind,I_2Lines(:,2),X0+1));

end