function Ia = anaglyph(Il,Ir, shiftx,shifty)

if(nargin < 3)
    shiftx = 0;
end
if(nargin < 4)
    shifty = 0;
end

[m,n,c] = size(Il);

Ia = zeros(m+shifty,n+shiftx,3);
jr1 = max(1, 1+shiftx);
jrn = min(n, n+shiftx);
ir1 = max(1, 1+shifty);
irm = min(m, m+shifty);

jl1 = max(1, 1-shiftx);
jln = min(n, n-shiftx);
il1 = max(1, 1-shifty);
ilm = min(m, m-shifty);

% the red channel is assigned with the left image
Ia(:,:,1) = Il(il1:ilm,jl1:jln,1);
% the green and blue channels are assigned with the right image
Ia(:,:,2:3) = Ir(ir1:irm,jr1:jrn,2:3);

