%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% carve.m - Carves out one seam from an image
%
% Input:  I - Image to work on (can be single or multi-channel)
%         x - seam vector
%
% Output: J - Retargeted image
%
% Carves out one (vertical) seam from image I, based on seam vector x.
% The vector x is the output of the function findOptimalSeam().
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function J = carve(I,x)

m = size(I,1);
n = size(I,2);
c = size(I,3);

J = zeros(m,n-1,c,class(I));

for j=1:c,
    for i=1:m,
        J(i,1:x(i)-1,j) = I(i,1:x(i)-1,j);
        J(i,x(i):n-1,j) = I(i,x(i)+1:n,j);
    end
end

return
