function [Iw, alpha] = imwarp(I,MapX,MapY,meth)
 
% defaults
if nargin == 3
    meth='linear';
end

[m,n] = size(I);
[x,y] = meshgrid(1:n,1:m);

 if meth=='nointerp'
    Iw = zeros(size(I));
    ind_ref = my_sub2ind([m,n],y,x);
    ind_map = my_sub2ind([m,n],MapY,MapX);
    Iw(ind_ref(ind_map > 0 & ind_map < n*m)) = I(ind_map(ind_map > 0 & ind_map < n*m));
    return;
end
    
Iw=interp2(x,y,double(I),MapX,MapY,meth,NaN);

if nargout == 2
    alpha = ~isnan(Iw);
end

Iw = double(Iw);
return;
